;======================================================
; Lemmy's Circus Ball
; By Erik557
;======================================================
; Description: A ball that will make Mario bounce if he
; collides with it.
; Uses first extra bit: NO
;======================================================


DATA_02BB88:
       db $FF,$01

DATA_02BB8E:
       db $E8,$18

;=================================
; INIT and MAIN Wrappers
;=================================

print "MAIN ",pc
       PHB
       PHK
       PLB
       JSR CheepCheep
       PLB
print "INIT ",pc
       RTL

;========================
; Main routine
;========================

CheepCheep:
       LDA #$18
       STA $9E,x
       JSL $0190B2
       LDA #$36
       STA $9E,x
       LDA $14C8,x
       CMP #$08
       BNE .return
       LDA $9D
       BNE .return
       LDY #$02
       JSR SubOffScreen
       JSL $01801A
       JSL $018022
       LDA $AA,x
       BMI +
       CMP #$3F
       BCS .dontIncSpeed
+      INC $AA,x
.dontIncSpeed
       TXA
       EOR $13
       LSR
       BCC +
       JSL $019138
+      LDA $AA,x
       BMI .dontSetSpeed
       LDA $164A,x
       BEQ .dontSetSpeed
       LDA $AA,x
       BEQ .dontZeroSpeed
       SEC
       SBC #$08
       STA $AA,x
       BPL .dontZeroSpeed
       STZ $AA,x
.dontZeroSpeed
       LDA $C2,x
       LSR
       AND #$00
       ROL
       TAY
       LDA $B6,x
       CLC
       ADC DATA_02BB88,y
       STA $B6,x
       CMP DATA_02BB8E,y
       BNE .dontSetSpeed
       LDA $157C,x
       EOR #$01
       STA $157C,x
+      INC $C2,x
.dontSetX
       LDA #$C0
       STA $AA,x
.dontSetSpeed
       JSL $01A7DC
       LDA $14
       LSR #3
       AND #$01
       STA $1602,x
.return
       RTS

;========================
; Misc. subroutines
;========================

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  SubOffScreen:           ;; - Optimized version
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Argument
; Y : type (#$00=X0, #$02=X1 ... #$0E=X7)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
       
       LDA $15A0,x
       ORA $186C,x
       BEQ .Return2
       LDA $167A,x
       AND #$04
       BNE .Return2
       LDA $5B
       LSR A
       BCS .VerticalLevel
       LDA $D8,x
       ADC #$50
       LDA $14D4,x
       ADC #$00
       CMP #$02
       BCS .EraseSprite
       LDA $14E0,x
       XBA
       LDA $E4,x
       REP #$21
       ADC .AddTable,y
       SEC
       SBC $1A
       CMP .CmpTable,y
.Common
       SEP #$20
       BCC .Return2
.EraseSprite
       LDA $14C8,x
       CMP #$08
       BCC .KillSprite
       LDY $161A,x
       CPY #$FF
       BEQ .KillSprite
       LDA $1938,y
       AND #$FE
       STA $1938,y
.KillSprite
       STZ $14C8,x
.Return2
       RTS

.VerticalLevel
       LDA $13
       LSR A
       BCS .CheckY
       LDA $14E0,x
       XBA
       LDA $E4,x
       REP #$21
       ADC.w #$0040
       CMP.w #$0280
       BRA .Common
.CheckY
       LDA $14D4,x
       XBA
       LDA $D8,x
       REP #$20
       SBC $1C
       CLC
       ADC.w #$0070
       CMP.w #$01D0
       BRA .Common

.AddTable
       dw $0040,$0040,$0010,$0070
       dw $0090,$0050,$0080,$FFC0
.CmpTable
       dw $0170,$01E0,$01B0,$01D0
       dw $0230,$01B0,$0220,$0160

